﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = CreateTable(4, 10).DefaultView;
        }

        public DataTable CreateTable(int columns, int rows)
        {
            DataTable d = new DataTable();
            Random r = new Random();

            for (int i = 0; i < columns; i++)
            {
                d.Columns.Add(new DataColumn("Column " + i, typeof(int)));
            }
            for (int i = 0; i < rows; i++)
            {
                DataRow row = d.NewRow();

                for (int j = 0; j < columns; j++)
                {
                    row["Column " + j] = r.Next(1000 * i);
                }

                d.Rows.Add(row);
            }
            return d;
        }

        private void xamGrid1_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Left)
            {
                xamGrid1.SelectionSettings.SelectedCells.Clear();
                e.Handled = true;
                if (xamGrid1.ActiveCell.Row.Cells.IndexOf(xamGrid1.ActiveCell) == 0 && xamGrid1.ActiveCell.Row.Index != 0)
                {
                    xamGrid1.ActiveCell = xamGrid1.Rows[xamGrid1.ActiveCell.Row.Index - 1].Cells[xamGrid1.Columns.Count - 1];                    
                }

                else if (xamGrid1.ActiveCell.Row.Cells.IndexOf(xamGrid1.ActiveCell) != 0)
                {
                    xamGrid1.ActiveCell = xamGrid1.ActiveCell.Row.Cells[xamGrid1.ActiveCell.Row.Cells.IndexOf(xamGrid1.ActiveCell) - 1];
                }
            }

            if (e.Key == Key.Right)
            {
                xamGrid1.SelectionSettings.SelectedCells.Clear();
                e.Handled = true;
                if (xamGrid1.ActiveCell.Row.Cells.IndexOf(xamGrid1.ActiveCell) == xamGrid1.Columns.Count - 1 
                    &&
                    xamGrid1.ActiveCell.Row.Index != xamGrid1.Rows.Count - 1)
                {
                    xamGrid1.ActiveCell = xamGrid1.Rows[xamGrid1.ActiveCell.Row.Index + 1].Cells[0];
                }

                else if (xamGrid1.ActiveCell.Row.Cells.IndexOf(xamGrid1.ActiveCell) != xamGrid1.Columns.Count - 1)
                {
                    xamGrid1.ActiveCell = xamGrid1.ActiveCell.Row.Cells[xamGrid1.ActiveCell.Row.Cells.IndexOf(xamGrid1.ActiveCell) + 1];
                }
            }

            if (e.Key == Key.Up)
            {
                xamGrid1.SelectionSettings.SelectedCells.Clear();
                e.Handled = true;

                if (xamGrid1.ActiveCell.Row.Index > 0)
                {
                    xamGrid1.ActiveCell = xamGrid1.Rows[xamGrid1.ActiveCell.Row.Index -1].Cells[xamGrid1.ActiveCell.Row.Cells.IndexOf(xamGrid1.ActiveCell)];
                }                
            }

            if (e.Key == Key.Down)
            {
                xamGrid1.SelectionSettings.SelectedCells.Clear();
                e.Handled = true;

                if (xamGrid1.ActiveCell.Row.Index < xamGrid1.Rows.Count - 1)
                {
                    xamGrid1.ActiveCell = xamGrid1.Rows[xamGrid1.ActiveCell.Row.Index + 1].Cells[xamGrid1.ActiveCell.Row.Cells.IndexOf(xamGrid1.ActiveCell)];
                }
            }
        }
    }
}
